SkillLabelTextboxControl = class(Turbine.UI.Control)
function SkillLabelTextboxControl:Constructor(parent, width, y, args, number)
    Turbine.UI.Control.Constructor(self)
    self:SetParent(parent)
    self:SetMouseVisible(false)
    self:SetPosition(0, y)
    self:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)

    self.width = width
    self.number = number

    self.label = Turbine.UI.Label()
    self.label:SetParent(self)
    self.label:SetPosition(5, 0)
    self.label:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold18)
    self.label:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.label:SetOutlineColor(Turbine.UI.Color.Black)
    self.label:SetForeColor(Turbine.UI.Color.White)
    self.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.label:SetText(args.Text)

    self.textbox = Turbine.UI.Lotro.TextBox()
    self.textbox:SetParent(self)
    self.textbox:SetForeColor(Turbine.UI.Color.White)
    self.textbox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold18)
    self.textbox:SetText(args.Value and tostring(args.Value))

    self.textbox.TextChanged = function ()
        self:ValueChanged()
    end

    self.effectButton = UI.Button()
    self.effectButton:SetParent(self)
    self.effectButton:SetPosition(20, 23)
    self.effectButton:SetSize(200, 20)
    self.effectButton:SetText("Browse All Skills")

    self.effectButton.MouseClick = function()
        if _G.AllSkillOverview then 
            _G.AllSkillOverview:SetVisible(not _G.AllSkillOverview:IsVisible())
        else
            _G.AllSkillOverview = Data.SkillOverview()
        end

        _G.AllSkillOverview:Register(self.textbox, nil)
    end

    self.oldSkillButton = UI.Button()
    self.oldSkillButton:SetParent(self)
    self.oldSkillButton:SetPosition(200, 23)
    self.oldSkillButton:SetSize(200, 20)
    self.oldSkillButton:SetText("Browse Current Skills")

    self.oldSkillButton.MouseClick = function()
        if _G.ClassSkillOverview then 
            _G.ClassSkillOverview:SetVisible(not _G.ClassSkillOverview:IsVisible())
        else
            _G.ClassSkillOverview = Data.SimpleSkillOverview()
            _G.ClassSkillOverview:SetVisible(true)
        end

        _G.ClassSkillOverview:Register(self.textbox, nil)
    end

    self:Format()
end

function SkillLabelTextboxControl:ValueChanged()

end

function SkillLabelTextboxControl:Format()
    self:SetSize(self.width, 45)
    self.label:SetSize(self.width * .3, 20)
    self.textbox:SetPosition(self.width * .3, 0)
    self.textbox:SetSize(self.width * .7, 20)
    self.effectButton:SetPosition(0, 23)
    self.effectButton:SetSize(180, 20)
    self.oldSkillButton:SetPosition(180, 23)
    self.oldSkillButton:SetSize(180, 20)
end

function SkillLabelTextboxControl:GetValue()
    if self.number then
        return tonumber(tostring(self.textbox:GetText()))
    else
        return tostring(self.textbox:GetText())
    end
end

function SkillLabelTextboxControl:SetValue(value)
    self.textbox:SetText(tostring(value))
end